# coding: utf-8

"""
    Cirro Data

    Cirro Data Platform service API

    The version of the OpenAPI document: latest
    Contact: support@cirro.bio
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import BaseModel, StrictStr, field_validator
from pydantic import Field
from typing_extensions import Annotated
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class CreateNotebookInstanceRequest(BaseModel):
    """
    CreateNotebookInstanceRequest
    """ # noqa: E501
    name: Annotated[str, Field(min_length=1, strict=True)]
    instance_type: Annotated[str, Field(min_length=1, strict=True)] = Field(description="AWS EC2 Instance Type (see list of available options)", alias="instanceType")
    accelerator_types: List[StrictStr] = Field(alias="acceleratorTypes")
    volume_size_gb: Annotated[int, Field(le=10000, strict=True, ge=10)] = Field(alias="volumeSizeGB")
    __properties: ClassVar[List[str]] = ["name", "instanceType", "acceleratorTypes", "volumeSizeGB"]

    @field_validator('instance_type')
    def instance_type_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"ml\.\w{2,4}\.\w*", value):
            raise ValueError(r"must validate the regular expression /ml\.\w{2,4}\.\w*/")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CreateNotebookInstanceRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of CreateNotebookInstanceRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "instanceType": obj.get("instanceType"),
            "acceleratorTypes": obj.get("acceleratorTypes"),
            "volumeSizeGB": obj.get("volumeSizeGB")
        })
        return _obj


