# coding: utf-8

"""
    Cirro Data

    Cirro Data Platform service API

    The version of the OpenAPI document: latest
    Contact: support@cirro.bio
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class Process(BaseModel):
    """
    Process
    """ # noqa: E501
    id: StrictStr = Field(description="Unique ID of the Process")
    name: Optional[StrictStr] = Field(default=None, description="Friendly name for the process")
    description: Optional[StrictStr] = None
    executor: Optional[Any] = None
    documentation_url: Optional[StrictStr] = Field(default=None, description="Link to pipeline documentation", alias="documentationUrl")
    file_requirements_message: Optional[StrictStr] = Field(default=None, description="Description of the files to be uploaded (optional)", alias="fileRequirementsMessage")
    child_process_ids: Optional[List[StrictStr]] = Field(default=None, description="IDs of pipelines that can be ran downstream", alias="childProcessIds")
    parent_process_ids: Optional[List[StrictStr]] = Field(default=None, description="IDs of pipelines that can run this pipeline", alias="parentProcessIds")
    owner: Optional[StrictStr] = Field(default=None, description="Username of the pipeline creator (blank if Cirro curated)")
    linked_project_ids: Optional[List[StrictStr]] = Field(default=None, description="Projects that can run this pipeline", alias="linkedProjectIds")
    __properties: ClassVar[List[str]] = ["id", "name", "description", "executor", "documentationUrl", "fileRequirementsMessage", "childProcessIds", "parentProcessIds", "owner", "linkedProjectIds"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of Process from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of executor
        if self.executor:
            _dict['executor'] = self.executor.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of Process from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "executor": Executor.from_dict(obj.get("executor")) if obj.get("executor") is not None else None,
            "documentationUrl": obj.get("documentationUrl"),
            "fileRequirementsMessage": obj.get("fileRequirementsMessage"),
            "childProcessIds": obj.get("childProcessIds"),
            "parentProcessIds": obj.get("parentProcessIds"),
            "owner": obj.get("owner"),
            "linkedProjectIds": obj.get("linkedProjectIds")
        })
        return _obj


