# coding: utf-8

"""
    Cirro Data

    Cirro Data Platform service API

    The version of the OpenAPI document: latest
    Contact: support@cirro.bio
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, field_validator
from pydantic import Field
from typing_extensions import Annotated
from cirro_api_client.models.repository_type import RepositoryType
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ProcessDetailAllOfPipelineCode(BaseModel):
    """
    ProcessDetailAllOfPipelineCode
    """ # noqa: E501
    repository_path: Annotated[str, Field(min_length=1, strict=True)] = Field(description="GitHub repository which contains the workflow code", alias="repositoryPath")
    version: Annotated[str, Field(min_length=1, strict=True)] = Field(description="Branch, tag, or commit hash of the pipeline code")
    repository_type: Optional[Any] = Field(default=None, alias="repositoryType")
    entry_point: Annotated[str, Field(min_length=1, strict=True)] = Field(description="Main script for running the pipeline", alias="entryPoint")
    __properties: ClassVar[List[str]] = ["repositoryPath", "version", "repositoryType", "entryPoint"]

    @field_validator('repository_path')
    def repository_path_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[\w-]+\/[\w-]+$", value):
            raise ValueError(r"must validate the regular expression /^[\w-]+\/[\w-]+$/")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ProcessDetailAllOfPipelineCode from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of repository_type
        if self.repository_type:
            _dict['repositoryType'] = self.repository_type.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ProcessDetailAllOfPipelineCode from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "repositoryPath": obj.get("repositoryPath"),
            "version": obj.get("version"),
            "repositoryType": RepositoryType.from_dict(obj.get("repositoryType")) if obj.get("repositoryType") is not None else None,
            "entryPoint": obj.get("entryPoint")
        })
        return _obj


