# coding: utf-8

"""
    Cirro Data

    Cirro Data Platform service API

    The version of the OpenAPI document: latest
    Contact: support@cirro.bio
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import BaseModel, StrictStr
from pydantic import Field
from cirro_api_client.models.resources_info import ResourcesInfo
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class SystemInfoResponse(BaseModel):
    """
    SystemInfoResponse
    """ # noqa: E501
    sdk_app_id: StrictStr = Field(alias="sdkAppId")
    resources_bucket: StrictStr = Field(alias="resourcesBucket")
    data_endpoint: StrictStr = Field(alias="dataEndpoint")
    region: StrictStr
    system_message: StrictStr = Field(alias="systemMessage")
    commit_hash: StrictStr = Field(alias="commitHash")
    version: StrictStr
    resources_info: ResourcesInfo = Field(alias="resourcesInfo")
    __properties: ClassVar[List[str]] = ["sdkAppId", "resourcesBucket", "dataEndpoint", "region", "systemMessage", "commitHash", "version", "resourcesInfo"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of SystemInfoResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of resources_info
        if self.resources_info:
            _dict['resourcesInfo'] = self.resources_info.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of SystemInfoResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sdkAppId": obj.get("sdkAppId"),
            "resourcesBucket": obj.get("resourcesBucket"),
            "dataEndpoint": obj.get("dataEndpoint"),
            "region": obj.get("region"),
            "systemMessage": obj.get("systemMessage"),
            "commitHash": obj.get("commitHash"),
            "version": obj.get("version"),
            "resourcesInfo": ResourcesInfo.from_dict(obj.get("resourcesInfo")) if obj.get("resourcesInfo") is not None else None
        })
        return _obj


