# coding: utf-8

"""
    Cirro Data

    Cirro Data Platform service API

    The version of the OpenAPI document: latest
    Contact: support@cirro.bio
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class Task(BaseModel):
    """
    Task
    """ # noqa: E501
    name: StrictStr
    native_job_id: StrictStr = Field(alias="nativeJobId")
    status: StrictStr
    requested_at: datetime = Field(alias="requestedAt")
    stopped_at: Optional[datetime] = Field(default=None, alias="stoppedAt")
    container_image: Optional[StrictStr] = Field(default=None, alias="containerImage")
    command_line: Optional[StrictStr] = Field(default=None, alias="commandLine")
    log_location: Optional[StrictStr] = Field(default=None, alias="logLocation")
    __properties: ClassVar[List[str]] = ["name", "nativeJobId", "status", "requestedAt", "stoppedAt", "containerImage", "commandLine", "logLocation"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of Task from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of Task from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "nativeJobId": obj.get("nativeJobId"),
            "status": obj.get("status"),
            "requestedAt": obj.get("requestedAt"),
            "stoppedAt": obj.get("stoppedAt"),
            "containerImage": obj.get("containerImage"),
            "commandLine": obj.get("commandLine"),
            "logLocation": obj.get("logLocation")
        })
        return _obj


